/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreGroupprivilege.TCoreGroupprivilegePath;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.TCorePrivilege.TCorePrivilegePath;
import de.ship.db.tables.TCoreUsergroup.TCoreUsergroupPath;
import de.ship.db.tables.records.TCoreGroupRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreGroup extends TableImpl<TCoreGroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_group</code>
     */
    public static final TCoreGroup T_CORE_GROUP = new TCoreGroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreGroupRecord> getRecordType() {
        return TCoreGroupRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_group.lastchange</code>.
     */
    public final TableField<TCoreGroupRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_group.pk</code>. unique id
     */
    public final TableField<TCoreGroupRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id");

    /**
     * The column <code>common_dd.t_core_group.name</code>. unique name of a
     * group
     */
    public final TableField<TCoreGroupRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "unique name of a group");

    private TCoreGroup(Name alias, Table<TCoreGroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreGroup(Name alias, Table<TCoreGroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_group</code> table reference
     */
    public TCoreGroup(String alias) {
        this(DSL.name(alias), T_CORE_GROUP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_group</code> table reference
     */
    public TCoreGroup(Name alias) {
        this(alias, T_CORE_GROUP);
    }

    /**
     * Create a <code>common_dd.t_core_group</code> table reference
     */
    public TCoreGroup() {
        this(DSL.name("t_core_group"), null);
    }

    public <O extends Record> TCoreGroup(Table<O> path, ForeignKey<O, TCoreGroupRecord> childPath, InverseForeignKey<O, TCoreGroupRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_GROUP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreGroupPath extends TCoreGroup implements Path<TCoreGroupRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreGroupPath(Table<O> path, ForeignKey<O, TCoreGroupRecord> childPath, InverseForeignKey<O, TCoreGroupRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreGroupPath(Name alias, Table<TCoreGroupRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreGroupPath as(String alias) {
            return new TCoreGroupPath(DSL.name(alias), this);
        }

        @Override
        public TCoreGroupPath as(Name alias) {
            return new TCoreGroupPath(alias, this);
        }

        @Override
        public TCoreGroupPath as(Table<?> alias) {
            return new TCoreGroupPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_GROUP);
    }

    @Override
    public Identity<TCoreGroupRecord, Integer> getIdentity() {
        return (Identity<TCoreGroupRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreGroupRecord> getPrimaryKey() {
        return Keys.PK_CORE_GROUP;
    }

    @Override
    public List<UniqueKey<TCoreGroupRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_GROUP);
    }

    private transient TCoreGroupprivilegePath _tCoreGroupprivilege;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_groupprivilege</code> table
     */
    public TCoreGroupprivilegePath tCoreGroupprivilege() {
        if (_tCoreGroupprivilege == null)
            _tCoreGroupprivilege = new TCoreGroupprivilegePath(this, null, Keys.T_CORE_GROUPPRIVILEGE__FK_CORE_GROUPPRIVILEGE_GROUP.getInverseKey());

        return _tCoreGroupprivilege;
    }

    private transient TCoreUsergroupPath _tCoreUsergroup;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_usergroup</code> table
     */
    public TCoreUsergroupPath tCoreUsergroup() {
        if (_tCoreUsergroup == null)
            _tCoreUsergroup = new TCoreUsergroupPath(this, null, Keys.T_CORE_USERGROUP__FK_CORE_USERGROUP_GROUP.getInverseKey());

        return _tCoreUsergroup;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_privilege</code> table
     */
    public TCorePrivilegePath tCorePrivilege() {
        return tCoreGroupprivilege().tCorePrivilege();
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_person</code> table
     */
    public TCorePersonPath tCorePerson() {
        return tCoreUsergroup().tCorePerson();
    }

    @Override
    public TCoreGroup as(String alias) {
        return new TCoreGroup(DSL.name(alias), this);
    }

    @Override
    public TCoreGroup as(Name alias) {
        return new TCoreGroup(alias, this);
    }

    @Override
    public TCoreGroup as(Table<?> alias) {
        return new TCoreGroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreGroup rename(String name) {
        return new TCoreGroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreGroup rename(Name name) {
        return new TCoreGroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreGroup rename(Table<?> name) {
        return new TCoreGroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroup where(Condition condition) {
        return new TCoreGroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
